/**
 * Copyright 2016 Rice University
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
 *  the specific language governing permissions and limitations under the License.
 */
library models.editor_file;

import 'package:vellum/models_file_types.dart';
import 'package:path/src/parsed_path.dart';

/**
 * An IDE file.
 */
class EditorFile<C>
{
  /**
   * The path of the file.
   */
  final ParsedPath path;

  /**
   * The file contents.
   */
  final C contents;

  /**
   * The type of the file.
   */
  final FileType fileType;

  /**
   * Creates a new editor file.
   */
  EditorFile(this.path, this.contents, this.fileType);
}