/**
 * Copyright 2016 Rice University
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
 *  the specific language governing permissions and limitations under the License.
 */
part of models.new_sourcefile_creation;

/**
 * Creates new Jave language [EditorFile]s given a class name.
 */
class NewSourceFileFactoryJava extends NewSourceFileFactory
{
  /**
   * Creates a new Java file named filename.jave where filename is the [uniqueFileBase] with first letter capitalized.
   */
  EditorFile makeSourceFile(String className)
  {
    String convertedClassName = capialize(className);

    return new EditorFile(new ParsedPath.parse(convertedClassName + ".java", new PosixStyle()),
        "public class " + convertedClassName + "\n{\n\n}", SourceLanguageJava);
  }

  String capialize(String filename)
  {
    return filename.substring(0, 1).toUpperCase() + filename.substring(1);
  }
}