/**
 * Copyright 2016 Rice University
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
 *  the specific language governing permissions and limitations under the License.
 */
part of view_models;

/**
 * An enumeration of file content types supported by [FileEditorViewModel].
 */
typedef dynamic ContentMode(JavaCase forJava, CCase forC, JavaScriptCase forJs);

ContentMode ContentModeJava = (JavaCase forJava, CCase forC, JavaScriptCase forJs) => forJava(null);

ContentMode ContentModeC = (JavaCase forJava, CCase forC, JavaScriptCase forJs) => forC(null);

ContentMode ContentModeJavaScript = (JavaCase forJava, CCase forC, JavaScriptCase forJs) => forJs(null);

/**
 * Support types for error revealing static analysis in the event that arguments are given in the wrong order
 * to invocations of [ContentMode].
 */
typedef dynamic JavaCase(JavaLanguageContent obj);

typedef dynamic CCase(CLanguageContent obj);

typedef dynamic JavaScriptCase(JavaScriptLanguageContent obj);

class JavaLanguageContent { }

class CLanguageContent { }

class JavaScriptLanguageContent { }