/**
 * Copyright 2016 Rice University
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
 *  the specific language governing permissions and limitations under the License.
 */
part of vellum.views;

/**
 * A navigation panel for selecting among open files for display in the IDE.
 *
 * [F] is the type used to represent files.
 */
abstract class ProjectExplorerView<F> implements View
{
  /**
   * Fired when a file selection has been made.
   */
  Stream<F> get onFileSelected;
}