/**
 * Copyright 2016 Rice University
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software distributed under the License is distributed
 *  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for
 *  the specific language governing permissions and limitations under the License.
 */
part of vellum.views;

/**
 * A showable / hidable IDE view component. The component should not be visible on the screen until [show()] is invoked.
 */
abstract class View
{
  /**
   * Displays this view component on the screen.
   */
  void show();

  /**
   * Hides the view component from the screen in a manner that does not retain any space on the layout.
   *
   * However, preserves view state for future [show()] calls.
   */
  void hide();
}